## mingw-w64-libgd-2.3.2-10.src.tar.zst

=== examples/CMakeLists.txt ===
include_directories (BEFORE "${GD_SOURCE_DIR}/src" "${CMAKE_BINARY_DIR}")

SET(TESTS_FILES
	gif
)

if (PNG_FOUND)
	LIST(APPEND TEST_FILES arc crop tgaread)

	if (JPEG_FOUND)
		LIST(APPEND TESTS_FILES copyrotated flip nnquant)
	endif (JPEG_FOUND)
endif (PNG_FOUND)

if (JPEG_FOUND)
	LIST(APPEND TESTS_FILES resize)
endif (JPEG_FOUND)

if (TIFF_FOUND)
	LIST(APPEND TESTS_FILES	tiffread)
endif (TIFF_FOUND)

if (BUILD_SHARED_LIBS)
	set(GD_LINK_LIB ${GD_LIB})
else()
	set(GD_LINK_LIB ${GD_LIB_STATIC})
endif()

FOREACH(test_name ${TESTS_FILES})
	add_executable(${test_name} "${test_name}.c")
	target_link_libraries (${test_name} ${GD_LINK_LIB})
ENDFOREACH(test_name)

# Add libraries *after* we've called add_executable on all the tests.

if (PNG_FOUND AND JPEG_FOUND)
	if (UNIX)
		target_link_libraries(copyrotated m)
	endif (UNIX)
endif(PNG_FOUND AND JPEG_FOUND)

if (WIN32 AND NOT MINGW AND NOT MSYS)
	add_executable(windows WIN32 "windows.c")
	target_link_libraries (windows ${GD_LINK_LIB})
else (WIN32 AND NOT MINGW AND NOT MSYS)
	if (MINGW OR MSYS)
		add_executable(windows "windows.c")
		add_definitions("-mwindows")
		target_link_libraries(windows ${GD_LINK_LIB} stdc++ gdi32)
	endif (MINGW OR MSYS)
endif (WIN32 AND NOT MINGW AND NOT MSYS)

=== tests/CMakeLists.txt ===
if (BUILD_TEST)
	SET(DART_TESTING_TIMEOUT 5)

	INCLUDE(Dart)

	set(GDTEST_SOURCE_DIR ${GD_SOURCE_DIR}/tests/gdtest)

	IF (ENABLE_GCOV AND CMAKE_COMPILER_IS_GNUCC)
		SET(CMAKE_BUILD_TYPE TESTINGGCOV)
		SET(CMAKE_CXX_FLAGS_TESTINGGCOV "-g3 -O0")
		SET(CMAKE_C_FLAGS_TESTINGGCOV "-g3 -O0")
	endif (ENABLE_GCOV AND CMAKE_COMPILER_IS_GNUCC)

	message(STATUS "gd include dir: ${GD_INCLUDE_DIR}" )
	message(STATUS "gd libs dir: ${GD_LIBS_DIR}" )

	include_directories (BEFORE ${GD_INCLUDE_DIR} "${GDTEST_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" "${CMAKE_BINARY_DIR}/tests/gdtest")

	SET(TESTS_DIRS
		avif
		bmp
		fontconfig
		freetype
		gd
		gd2
		gdimagearc
		gdimagebrightness
		gdimageclone
		gdimagecolor
		gdimagecolorclosest
		gdimagecolorclosesthwb
		gdimagecolordeallocate
		gdimagecolorexact
		gdimagecolormatch
		gdimagecolorreplace
		gdimagecolorresolve
		gdimagecolortransparent
		gdimagecompare
		gdimagecontrast
		gdimageconvolution
		gdimagecopy
		gdimagecopymerge
		gdimagecopymergegray
		gdimagecopyresampled
		gdimagecopyresized
		gdimagecopyrotated
		gdimagecreate
		gdimagecrop
		gdimagefile
		gdimagefill
		gdimagefilledarc
		gdimagefilledellipse
		gdimagefilledpolygon
		gdimagefilledrectangle
		gdimagefilltoborder
		gdimagefilter
		gdimageflip
		gdimageellipse
		gdimagegrayscale
		gdimageline
		gdimagenegate
		gdimageopenpolygon
		gdimagepixelate
		gdimagepolygon
		gdimagerectangle
		gdimagerotate
		gdimagescale
		gdimagescatterex
		gdimagesetinterpolationmethod
		gdimagesetpixel
		gdimagesquaretocircle
		gdimagestring
		gdimagestring16
		gdimagestringft
		gdimagestringftex
		gdimagestringup
		gdimagestringup16
		gdimagetruecolortopalette
		gdinterpolatedscale
		gdnewfilectx
		gdtest
		gdtiled
		gdtransformaffineboundingbox
		gdtransformaffinecopy
		gif
		heif
		jpeg
		png
		tga
		tiff
		wbmp
		webp
		xbm
		xpm
	)

	FOREACH(test_dir ${TESTS_DIRS})
		add_subdirectory (${test_dir})
	ENDFOREACH(test_dir)

endif (BUILD_TEST)

=== tests/bmp/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	bmp_null
	bug00275
	bug00450
	bmp_im2im
	bug00276
)

ADD_GD_TESTS()

=== tests/gdtransformaffinecopy/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	github_bug_00583
	github_bug_00585
	github_bug_00586
	github_bug_00596
)

ADD_GD_TESTS()

=== tests/png/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	png_im2im
	png_null
	png_resolution
	bug00011
	bug00033
	bug00086
	bug00088
	bug00193
	bug00338
	bug00381_1
)

IF(ENABLE_GD_FORMATS)
LIST(APPEND TESTS_FILES
	bug00381_2
)
ENDIF(ENABLE_GD_FORMATS)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== PKGBUILD ===
# Maintainer: Peter Budai <peterbudai at hotmail dot com>

_realname=libgd
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2.3.2
pkgrel=10
pkgdesc="GD is an open source code library for the dynamic creation of images by programmers (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
msys2_references=(
  'archlinux: gd'
  'cpe: cpe:/a:libgd:libgd'
)
url="https://libgd.github.io/"
license=("custom")
depends=("${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libiconv"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libavif"
         "${MINGW_PACKAGE_PREFIX}-libheif"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         $([[ "${CARCH}" == "i686" ]] || echo "${MINGW_PACKAGE_PREFIX}-libimagequant")
         "${MINGW_PACKAGE_PREFIX}-libwebp"
         "${MINGW_PACKAGE_PREFIX}-xpm-nox"
         "${MINGW_PACKAGE_PREFIX}-zlib")
replaces=("${MINGW_PACKAGE_PREFIX}-gd")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("${_realname}-${pkgver}.tar.gz"::"https://github.com/libgd/libgd/releases/download/gd-${pkgver}/${_realname}-${pkgver}.tar.gz"
        "libgd-export-pkg-config-build-in-subdirs.patch"
        "mingw-replace-posix_memalign.patch"
        "mingw-getline-link.patch")
sha256sums=('ee0c74852c102140fc590541950127b63a3c6fa4592305c16738d23ed65f8ac3'
            'cd8b1a2dc1515d717c7359d787ff08138af449512ed9280859b5a630886a65e1'
            'c3e69c7e59c280e5cc561c984c906b5cfa5ee56aff0b173c0febfdbf90cb048f'
            'b52ec6485d43b511b9b399cda41fc85d5f15f5ebccad1dfc76bb89b451aae512')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  #This patch actually does more than simply export dirs into a subdir
  #It also is responsible for creating the pkg_config file and now also
  #the gdlib-config file that some build scripts seem to still require
  #in spite of that mechanism being depreciated.
  patch -Nbp1 -i "${srcdir}/libgd-export-pkg-config-build-in-subdirs.patch"
  patch -Nbp1 -i "${srcdir}/mingw-replace-posix_memalign.patch"
  patch -Nbp1 -i "${srcdir}/mingw-getline-link.patch"

  sed -i "s/libavif 0.8.2 /libavif /" CMakeLists.txt
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if [ "${CARCH}" != "i686" ]; then
    _extra_config+=(
      "-DENABLE_LIQ=ON"
      "-DLIQ_INCLUDE_DIR=${MINGW_PREFIX}/include/libimagequant"
    )
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe             \
    -GNinja                                 \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX}  \
    -DBUILD_{SHARED,STATIC}_LIBS=ON         \
    -DENABLE_AVIF=ON                        \
    -DENABLE_HEIF=ON                        \
    -DENABLE_FONTCONFIG=ON                  \
    -DENABLE_PNG=ON                         \
    -DENABLE_JPEG=ON                        \
    -DENABLE_TIFF=ON                        \
    -DENABLE_ICONV=ON                       \
    -DENABLE_XPM=ON                         \
    -DENABLE_FREETYPE=ON                    \
    -DENABLE_WEBP=ON                        \
    -DENABLE_GD_FORMATS=ON                  \
    -DXPM_XPM_INCLUDE_DIR="${MINGW_PREFIX}/include/X11" \
    -DWEBP_INCLUDE_DIR="${MINGW_PREFIX}/include/webp/" \
    -DFREETYPE_INCLUDE_DIR_freetype2="${MINGW_PREFIX}/include/freetype2" \
    -DFREETYPE_INCLUDE_DIRS="${MINGW_PREFIX}/include/freetype2" \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  files=("/lib/pkgconfig/gdlib.pc")
  for f in "${files[@]}"
  do
    sed -e "s|${PREFIX_WIN}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}${f}
  done
}
